-- file: createProcedures2Pg.sql
-- modified: 5/1/07  1:45a 



-- ------------------------------------------------------------------------------------------

-- create type to return the data we need

DROP TYPE ms_involvedInCase_tuple CASCADE;

CREATE TYPE ms_involvedInCase_tuple AS (
  lognm VARCHAR,
  lastnm VARCHAR,
  firstnm VARCHAR,
  rol VARCHAR,
  success INTEGER);


-- output logname, last name, first name, role for an
-- account associated with a given caseID
CREATE OR REPLACE FUNCTION ms_getInvolvedInCase (cID INTEGER) RETURNS MS_INVOLVEDINCASE_TUPLE AS $$

DECLARE
  result MS_INVOLVEDINCASE_TUPLE;

BEGIN
  SELECT ACR.logname, A.lastName, A.firstName, ACR.role
  INTO result.lognm, result.lastnm, result.firstnm, result.rol
  FROM ms_account A, ms_accountCaseRole ACR
  WHERE ACR.caseID = cID AND
        ACR.logname = A.logname;
  IF result.lognm IS NOT NULL THEN
    result.success = 1;
  ELSE
    result.success = 0;
  END IF;

  RETURN result;

EXCEPTION
  WHEN OTHERS THEN
    result.success = -1;
    RETURN result;

END;

$$ LANGUAGE plpgsql;

-- ---------------------------------------------------------------------------


